# openapi
A powerful way to send personalized messages at scale and build effective customer engagement strategies. Learn more at onesignal.com

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.1
- Build package: org.openapitools.codegen.languages.DartClientCodegen
For more information, please visit [https://onesignal.com](https://onesignal.com)

## Requirements

Dart 2.12 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  openapi:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  openapi:
    path: /path/to/openapi
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:openapi/api.dart';

// TODO Configure HTTP Bearer authorization: app_key
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('app_key').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('app_key').setAccessToken(yourTokenGeneratorFunction);

final api_instance = DefaultApi();
final appId = appId_example; // String | 
final notificationId = notificationId_example; // String | 

try {
    final result = api_instance.cancelNotification(appId, notificationId);
    print(result);
} catch (e) {
    print('Exception when calling DefaultApi->cancelNotification: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *https://onesignal.com/api/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**cancelNotification**](doc//DefaultApi.md#cancelnotification) | **DELETE** /notifications/{notification_id} | Stop a scheduled or currently outgoing notification
*DefaultApi* | [**createApp**](doc//DefaultApi.md#createapp) | **POST** /apps | Create an app
*DefaultApi* | [**createNotification**](doc//DefaultApi.md#createnotification) | **POST** /notifications | Create notification
*DefaultApi* | [**createPlayer**](doc//DefaultApi.md#createplayer) | **POST** /players | Add a device
*DefaultApi* | [**createSegments**](doc//DefaultApi.md#createsegments) | **POST** /apps/{app_id}/segments | Create Segments
*DefaultApi* | [**deletePlayer**](doc//DefaultApi.md#deleteplayer) | **DELETE** /players/{player_id} | Delete a user record
*DefaultApi* | [**deleteSegments**](doc//DefaultApi.md#deletesegments) | **DELETE** /apps/{app_id}/segments/{segment_id} | Delete Segments
*DefaultApi* | [**exportPlayers**](doc//DefaultApi.md#exportplayers) | **POST** /players/csv_export?app_id={app_id} | CSV export
*DefaultApi* | [**getApp**](doc//DefaultApi.md#getapp) | **GET** /apps/{app_id} | View an app
*DefaultApi* | [**getApps**](doc//DefaultApi.md#getapps) | **GET** /apps | View apps
*DefaultApi* | [**getNotification**](doc//DefaultApi.md#getnotification) | **GET** /notifications/{notification_id} | View notification
*DefaultApi* | [**getNotificationHistory**](doc//DefaultApi.md#getnotificationhistory) | **POST** /notifications/{notification_id}/history | Notification History
*DefaultApi* | [**getNotifications**](doc//DefaultApi.md#getnotifications) | **GET** /notifications | View notifications
*DefaultApi* | [**getOutcomes**](doc//DefaultApi.md#getoutcomes) | **GET** /apps/{app_id}/outcomes | View Outcomes
*DefaultApi* | [**getPlayer**](doc//DefaultApi.md#getplayer) | **GET** /players/{player_id} | View device
*DefaultApi* | [**getPlayers**](doc//DefaultApi.md#getplayers) | **GET** /players | View devices
*DefaultApi* | [**updateApp**](doc//DefaultApi.md#updateapp) | **PUT** /apps/{app_id} | Update an app
*DefaultApi* | [**updatePlayer**](doc//DefaultApi.md#updateplayer) | **PUT** /players/{player_id} | Edit device
*DefaultApi* | [**updatePlayerTags**](doc//DefaultApi.md#updateplayertags) | **PUT** /apps/{app_id}/users/{external_user_id} | Edit tags with external user id


## Documentation For Models

 - [App](doc//App.md)
 - [Button](doc//Button.md)
 - [CancelNotificationSuccessResponse](doc//CancelNotificationSuccessResponse.md)
 - [CreateNotificationBadRequestResponse](doc//CreateNotificationBadRequestResponse.md)
 - [CreateNotificationSuccessResponse](doc//CreateNotificationSuccessResponse.md)
 - [CreatePlayerSuccessResponse](doc//CreatePlayerSuccessResponse.md)
 - [CreateSegmentBadRequestResponse](doc//CreateSegmentBadRequestResponse.md)
 - [CreateSegmentConflictResponse](doc//CreateSegmentConflictResponse.md)
 - [CreateSegmentSuccessResponse](doc//CreateSegmentSuccessResponse.md)
 - [DeletePlayerBadRequestResponse](doc//DeletePlayerBadRequestResponse.md)
 - [DeletePlayerNotFoundResponse](doc//DeletePlayerNotFoundResponse.md)
 - [DeletePlayerSuccessResponse](doc//DeletePlayerSuccessResponse.md)
 - [DeleteSegmentBadRequestResponse](doc//DeleteSegmentBadRequestResponse.md)
 - [DeleteSegmentNotFoundResponse](doc//DeleteSegmentNotFoundResponse.md)
 - [DeleteSegmentSuccessResponse](doc//DeleteSegmentSuccessResponse.md)
 - [DeliveryData](doc//DeliveryData.md)
 - [ExportPlayersRequestBody](doc//ExportPlayersRequestBody.md)
 - [ExportPlayersSuccessResponse](doc//ExportPlayersSuccessResponse.md)
 - [Filter](doc//Filter.md)
 - [FilterExpressions](doc//FilterExpressions.md)
 - [FilterNotificationTarget](doc//FilterNotificationTarget.md)
 - [GetNotificationRequestBody](doc//GetNotificationRequestBody.md)
 - [InvalidIdentifierError](doc//InvalidIdentifierError.md)
 - [ModelOperator](doc//ModelOperator.md)
 - [Notification](doc//Notification.md)
 - [Notification200Errors](doc//Notification200Errors.md)
 - [NotificationAllOf](doc//NotificationAllOf.md)
 - [NotificationAllOfAndroidBackgroundLayout](doc//NotificationAllOfAndroidBackgroundLayout.md)
 - [NotificationHistoryBadRequestResponse](doc//NotificationHistoryBadRequestResponse.md)
 - [NotificationHistorySuccessResponse](doc//NotificationHistorySuccessResponse.md)
 - [NotificationSlice](doc//NotificationSlice.md)
 - [NotificationTarget](doc//NotificationTarget.md)
 - [NotificationWithMeta](doc//NotificationWithMeta.md)
 - [NotificationWithMetaAllOf](doc//NotificationWithMetaAllOf.md)
 - [OutcomeData](doc//OutcomeData.md)
 - [OutcomesData](doc//OutcomesData.md)
 - [PlatformDeliveryData](doc//PlatformDeliveryData.md)
 - [Player](doc//Player.md)
 - [PlayerNotificationTarget](doc//PlayerNotificationTarget.md)
 - [PlayerSlice](doc//PlayerSlice.md)
 - [Purchase](doc//Purchase.md)
 - [Segment](doc//Segment.md)
 - [SegmentNotificationTarget](doc//SegmentNotificationTarget.md)
 - [StringMap](doc//StringMap.md)
 - [UpdatePlayerSuccessResponse](doc//UpdatePlayerSuccessResponse.md)
 - [UpdatePlayerTagsRequestBody](doc//UpdatePlayerTagsRequestBody.md)
 - [UpdatePlayerTagsSuccessResponse](doc//UpdatePlayerTagsSuccessResponse.md)


## Documentation For Authorization


## app_key

- **Type**: HTTP Bearer authentication

## user_key

- **Type**: HTTP Bearer authentication


## Author

devrel@onesignal.com

