//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of one_signal_api;

class DefaultApi {
  DefaultApi([ApiClient? apiClient])
      : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Stop a scheduled or currently outgoing notification
  ///
  /// Used to stop a scheduled or currently outgoing notification
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///
  /// * [String] notificationId (required):
  Future<Response> cancelNotificationWithHttpInfo(
    String appId,
    String notificationId,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/notifications/{notification_id}'
        .replaceAll('{notification_id}', notificationId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    queryParams.addAll(_queryParams('', 'app_id', appId));

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Stop a scheduled or currently outgoing notification
  ///
  /// Used to stop a scheduled or currently outgoing notification
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///
  /// * [String] notificationId (required):
  Future<CancelNotificationSuccessResponse?> cancelNotification(
    String appId,
    String notificationId,
  ) async {
    final response = await cancelNotificationWithHttpInfo(
      appId,
      notificationId,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'CancelNotificationSuccessResponse',
      ) as CancelNotificationSuccessResponse;
    }
    return null;
  }

  /// Create an app
  ///
  /// Creates a new OneSignal app
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [App] app (required):
  Future<Response> createAppWithHttpInfo(
    App app,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/apps';

    // ignore: prefer_final_locals
    Object? postBody = app;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create an app
  ///
  /// Creates a new OneSignal app
  ///
  /// Parameters:
  ///
  /// * [App] app (required):
  Future<App?> createApp(
    App app,
  ) async {
    final response = await createAppWithHttpInfo(
      app,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'App',
      ) as App;
    }
    return null;
  }

  /// Create notification
  ///
  /// Sends notifications to your users
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [Notification] notification (required):
  Future<Response> createNotificationWithHttpInfo(
    Notification notification,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/notifications';

    // ignore: prefer_final_locals
    Object? postBody = notification;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create notification
  ///
  /// Sends notifications to your users
  ///
  /// Parameters:
  ///
  /// * [Notification] notification (required):
  Future<CreateNotificationSuccessResponse?> createNotification(
    Notification notification,
  ) async {
    final response = await createNotificationWithHttpInfo(
      notification,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'CreateNotificationSuccessResponse',
      ) as CreateNotificationSuccessResponse;
    }
    return null;
  }

  /// Add a device
  ///
  /// Register a new device to one of your OneSignal apps &#x1F6A7; Don't use this This API endpoint is designed to be used from our open source Mobile and Web Push SDKs. It is not designed for developers to use it directly, unless instructed to do so by OneSignal support. If you use this method instead of our SDKs, many OneSignal features such as conversion tracking, timezone tracking, language detection, and rich-push won't work out of the box. It will also make it harder to identify possible setup issues. This method is used to register a new device with OneSignal. If a device is already registered with the specified identifier, then this will update the existing device record instead of creating a new one. The returned player is a player / user ID. Use the returned ID to send push notifications to this specific user later, or to include this player when sending to a set of users. &#x1F6A7; iOS Must set test_type to 1 when building your iOS app as development. Omit this field in your production app builds.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [Player] player (required):
  Future<Response> createPlayerWithHttpInfo(
    Player player,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/players';

    // ignore: prefer_final_locals
    Object? postBody = player;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Add a device
  ///
  /// Register a new device to one of your OneSignal apps &#x1F6A7; Don't use this This API endpoint is designed to be used from our open source Mobile and Web Push SDKs. It is not designed for developers to use it directly, unless instructed to do so by OneSignal support. If you use this method instead of our SDKs, many OneSignal features such as conversion tracking, timezone tracking, language detection, and rich-push won't work out of the box. It will also make it harder to identify possible setup issues. This method is used to register a new device with OneSignal. If a device is already registered with the specified identifier, then this will update the existing device record instead of creating a new one. The returned player is a player / user ID. Use the returned ID to send push notifications to this specific user later, or to include this player when sending to a set of users. &#x1F6A7; iOS Must set test_type to 1 when building your iOS app as development. Omit this field in your production app builds.
  ///
  /// Parameters:
  ///
  /// * [Player] player (required):
  Future<CreatePlayerSuccessResponse?> createPlayer(
    Player player,
  ) async {
    final response = await createPlayerWithHttpInfo(
      player,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'CreatePlayerSuccessResponse',
      ) as CreatePlayerSuccessResponse;
    }
    return null;
  }

  /// Create Segments
  ///
  /// Create segments visible and usable in the dashboard and API - Required: OneSignal Paid Plan The Create Segment method is used when you want your server to programmatically create a segment instead of using the OneSignal Dashboard UI. Just like creating Segments from the dashboard you can pass in filters with multiple \"AND\" or \"OR\" operator's. &#x1F6A7; Does Not Update Segments This endpoint will only create segments, it does not edit or update currently created Segments. You will need to use the Delete Segments endpoint and re-create it with this endpoint to edit.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID for your app.  Available in Keys & IDs.
  ///
  /// * [Segment] segment:
  Future<Response> createSegmentsWithHttpInfo(
    String appId, {
    Segment? segment,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/apps/{app_id}/segments'.replaceAll('{app_id}', appId);

    // ignore: prefer_final_locals
    Object? postBody = segment;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create Segments
  ///
  /// Create segments visible and usable in the dashboard and API - Required: OneSignal Paid Plan The Create Segment method is used when you want your server to programmatically create a segment instead of using the OneSignal Dashboard UI. Just like creating Segments from the dashboard you can pass in filters with multiple \"AND\" or \"OR\" operator's. &#x1F6A7; Does Not Update Segments This endpoint will only create segments, it does not edit or update currently created Segments. You will need to use the Delete Segments endpoint and re-create it with this endpoint to edit.
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID for your app.  Available in Keys & IDs.
  ///
  /// * [Segment] segment:
  Future<CreateSegmentSuccessResponse?> createSegments(
    String appId, {
    Segment? segment,
  }) async {
    final response = await createSegmentsWithHttpInfo(
      appId,
      segment: segment,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'CreateSegmentSuccessResponse',
      ) as CreateSegmentSuccessResponse;
    }
    return null;
  }

  /// Delete a user record
  ///
  /// Delete player - Required: Used to delete a single, specific Player ID record from a specific OneSignal app.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID for your app.  Available in Keys & IDs.
  ///
  /// * [String] playerId (required):
  ///   The OneSignal player_id
  Future<Response> deletePlayerWithHttpInfo(
    String appId,
    String playerId,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/players/{player_id}'.replaceAll('{player_id}', playerId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    queryParams.addAll(_queryParams('', 'app_id', appId));

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Delete a user record
  ///
  /// Delete player - Required: Used to delete a single, specific Player ID record from a specific OneSignal app.
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID for your app.  Available in Keys & IDs.
  ///
  /// * [String] playerId (required):
  ///   The OneSignal player_id
  Future<DeletePlayerSuccessResponse?> deletePlayer(
    String appId,
    String playerId,
  ) async {
    final response = await deletePlayerWithHttpInfo(
      appId,
      playerId,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'DeletePlayerSuccessResponse',
      ) as DeletePlayerSuccessResponse;
    }
    return null;
  }

  /// Delete Segments
  ///
  /// Delete segments (not user devices) - Required: OneSignal Paid Plan You can delete a segment under your app by calling this API. You must provide an API key in the Authorization header that has admin access on the app. The segment_id can be found in the URL of the segment when viewing it in the dashboard.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID for your app.  Available in Keys & IDs.
  ///
  /// * [String] segmentId (required):
  ///   The segment_id can be found in the URL of the segment when viewing it in the dashboard.
  Future<Response> deleteSegmentsWithHttpInfo(
    String appId,
    String segmentId,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/apps/{app_id}/segments/{segment_id}'
        .replaceAll('{app_id}', appId)
        .replaceAll('{segment_id}', segmentId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Delete Segments
  ///
  /// Delete segments (not user devices) - Required: OneSignal Paid Plan You can delete a segment under your app by calling this API. You must provide an API key in the Authorization header that has admin access on the app. The segment_id can be found in the URL of the segment when viewing it in the dashboard.
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID for your app.  Available in Keys & IDs.
  ///
  /// * [String] segmentId (required):
  ///   The segment_id can be found in the URL of the segment when viewing it in the dashboard.
  Future<DeleteSegmentSuccessResponse?> deleteSegments(
    String appId,
    String segmentId,
  ) async {
    final response = await deleteSegmentsWithHttpInfo(
      appId,
      segmentId,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'DeleteSegmentSuccessResponse',
      ) as DeleteSegmentSuccessResponse;
    }
    return null;
  }

  /// CSV export
  ///
  /// Generate a compressed CSV export of all of your current user data This method can be used to generate a compressed CSV export of all of your current user data. It is a much faster alternative than retrieving this data using the /players API endpoint. The file will be compressed using GZip. The file may take several minutes to generate depending on the number of users in your app. The URL generated will be available for 3 days and includes random v4 uuid as part of the resource name to be unguessable. &#x1F6A7; 403 Error Responses          You can test if it is complete by making a GET request to the csv_file_url value. This file may take time to generate depending on how many device records are being pulled. If the file is not ready, a 403 error will be returned. Otherwise the file itself will be returned. &#x1F6A7; Requires Authentication Key Requires your OneSignal App's REST API Key, available in Keys & IDs. &#x1F6A7; Concurrent Exports Only one concurrent export is allowed per OneSignal account. Please ensure you have successfully downloaded the .csv.gz file before exporting another app. CSV File Format: - Default Columns:   | Field | Details |   | --- | --- |   | id | OneSignal Player Id |   | identifier | Push Token |   | session_count | Number of times they visited the app or site   | language | Device language code |   | timezone | Number of seconds away from UTC. Example: -28800 |   | game_version | Version of your mobile app gathered from Android Studio versionCode in your App/build.gradle and iOS uses kCFBundleVersionKey in Xcode. |   | device_os | Device Operating System Version. Example: 80 = Chrome 80, 9 = Android 9 |   | device_type | Device Operating System Type |   | device_model | Device Hardware String Code. Example: Mobile Web Subscribers will have `Linux armv` |   | ad_id | Based on the Google Advertising Id for Android, identifierForVendor for iOS. OptedOut means user turned off Advertising tracking on the device. |   | tags | Current OneSignal Data Tags on the device. |   | last_active | Date and time the user last opened the mobile app or visited the site. |   | playtime | Total amount of time in seconds the user had the mobile app open. |   | amount_spent |  Mobile only - amount spent in USD on In-App Purchases. |    | created_at | Date and time the device record was created in OneSignal. Mobile - first time they opened the app with OneSignal SDK. Web - first time the user subscribed to the site. |   | invalid_identifier | t = unsubscribed, f = subscibed |   | badge_count | Current number of badges on the device | - Extra Columns:   | Field | Details |   | --- | --- |   | external_user_id | Your User Id set on the device |   | notification_types | Notification types |   | location | Location points (Latitude and Longitude) set on the device. |   | country | Country code |   | rooted | Android device rooted or not |   | ip | IP Address of the device if being tracked. See Handling Personal Data. |   | web_auth | Web Only authorization key. |   | web_p256 | Web Only p256 key. |
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The app ID that you want to export devices from
  ///
  /// * [ExportPlayersRequestBody] exportPlayersRequestBody:
  Future<Response> exportPlayersWithHttpInfo(
    String appId, {
    ExportPlayersRequestBody? exportPlayersRequestBody,
  }) async {
    // ignore: prefer_const_declarations
    final path =
        r'/players/csv_export?app_id={app_id}'.replaceAll('{app_id}', appId);

    // ignore: prefer_final_locals
    Object? postBody = exportPlayersRequestBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// CSV export
  ///
  /// Generate a compressed CSV export of all of your current user data This method can be used to generate a compressed CSV export of all of your current user data. It is a much faster alternative than retrieving this data using the /players API endpoint. The file will be compressed using GZip. The file may take several minutes to generate depending on the number of users in your app. The URL generated will be available for 3 days and includes random v4 uuid as part of the resource name to be unguessable. &#x1F6A7; 403 Error Responses          You can test if it is complete by making a GET request to the csv_file_url value. This file may take time to generate depending on how many device records are being pulled. If the file is not ready, a 403 error will be returned. Otherwise the file itself will be returned. &#x1F6A7; Requires Authentication Key Requires your OneSignal App's REST API Key, available in Keys & IDs. &#x1F6A7; Concurrent Exports Only one concurrent export is allowed per OneSignal account. Please ensure you have successfully downloaded the .csv.gz file before exporting another app. CSV File Format: - Default Columns:   | Field | Details |   | --- | --- |   | id | OneSignal Player Id |   | identifier | Push Token |   | session_count | Number of times they visited the app or site   | language | Device language code |   | timezone | Number of seconds away from UTC. Example: -28800 |   | game_version | Version of your mobile app gathered from Android Studio versionCode in your App/build.gradle and iOS uses kCFBundleVersionKey in Xcode. |   | device_os | Device Operating System Version. Example: 80 = Chrome 80, 9 = Android 9 |   | device_type | Device Operating System Type |   | device_model | Device Hardware String Code. Example: Mobile Web Subscribers will have `Linux armv` |   | ad_id | Based on the Google Advertising Id for Android, identifierForVendor for iOS. OptedOut means user turned off Advertising tracking on the device. |   | tags | Current OneSignal Data Tags on the device. |   | last_active | Date and time the user last opened the mobile app or visited the site. |   | playtime | Total amount of time in seconds the user had the mobile app open. |   | amount_spent |  Mobile only - amount spent in USD on In-App Purchases. |    | created_at | Date and time the device record was created in OneSignal. Mobile - first time they opened the app with OneSignal SDK. Web - first time the user subscribed to the site. |   | invalid_identifier | t = unsubscribed, f = subscibed |   | badge_count | Current number of badges on the device | - Extra Columns:   | Field | Details |   | --- | --- |   | external_user_id | Your User Id set on the device |   | notification_types | Notification types |   | location | Location points (Latitude and Longitude) set on the device. |   | country | Country code |   | rooted | Android device rooted or not |   | ip | IP Address of the device if being tracked. See Handling Personal Data. |   | web_auth | Web Only authorization key. |   | web_p256 | Web Only p256 key. |
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The app ID that you want to export devices from
  ///
  /// * [ExportPlayersRequestBody] exportPlayersRequestBody:
  Future<ExportPlayersSuccessResponse?> exportPlayers(
    String appId, {
    ExportPlayersRequestBody? exportPlayersRequestBody,
  }) async {
    final response = await exportPlayersWithHttpInfo(
      appId,
      exportPlayersRequestBody: exportPlayersRequestBody,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'ExportPlayersSuccessResponse',
      ) as ExportPlayersSuccessResponse;
    }
    return null;
  }

  /// View an app
  ///
  /// View the details of a single OneSignal app
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   An app id
  Future<Response> getAppWithHttpInfo(
    String appId,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/apps/{app_id}'.replaceAll('{app_id}', appId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View an app
  ///
  /// View the details of a single OneSignal app
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   An app id
  Future<App?> getApp(
    String appId,
  ) async {
    final response = await getAppWithHttpInfo(
      appId,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'App',
      ) as App;
    }
    return null;
  }

  /// View apps
  ///
  /// View the details of all of your current OneSignal apps
  ///
  /// Note: This method returns the HTTP [Response].
  Future<Response> getAppsWithHttpInfo() async {
    // ignore: prefer_const_declarations
    final path = r'/apps';

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View apps
  ///
  /// View the details of all of your current OneSignal apps
  Future<List<App>?> getApps() async {
    final response = await getAppsWithHttpInfo();
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<App>')
              as List)
          .cast<App>()
          .toList();
    }
    return null;
  }

  /// View notification
  ///
  /// View the details of a single notification and outcomes associated with it
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///
  /// * [String] notificationId (required):
  Future<Response> getNotificationWithHttpInfo(
    String appId,
    String notificationId,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/notifications/{notification_id}'
        .replaceAll('{notification_id}', notificationId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    queryParams.addAll(_queryParams('', 'app_id', appId));

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View notification
  ///
  /// View the details of a single notification and outcomes associated with it
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///
  /// * [String] notificationId (required):
  Future<NotificationWithMeta?> getNotification(
    String appId,
    String notificationId,
  ) async {
    final response = await getNotificationWithHttpInfo(
      appId,
      notificationId,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'NotificationWithMeta',
      ) as NotificationWithMeta;
    }
    return null;
  }

  /// Notification History
  ///
  /// -> View the devices sent a message - OneSignal Paid Plan Required This method will return all devices that were sent the given notification_id of an Email or Push Notification if used within 7 days of the date sent. After 7 days of the sending date, the message history data will be unavailable. After a successful response is received, the destination url may be polled until the file becomes available. Most exports are done in ~1-3 minutes, so setting a poll interval of 10 seconds should be adequate. For use cases that are not meant to be consumed by a script, an email will be sent to the supplied email address. &#x1F6A7; Requirements A OneSignal Paid Plan. Turn on Send History via OneSignal API in Settings -> Analytics. Cannot get data before this was turned on. Must be called within 7 days after sending the message. Messages targeting under 1000 recipients will not have \"sent\" events recorded, but will show \"clicked\" events. Requires your OneSignal App's REST API Key, available in Keys & IDs.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] notificationId (required):
  ///   The \"id\" of the message found in the Notification object
  ///
  /// * [GetNotificationRequestBody] getNotificationRequestBody (required):
  Future<Response> getNotificationHistoryWithHttpInfo(
    String notificationId,
    GetNotificationRequestBody getNotificationRequestBody,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/notifications/{notification_id}/history'
        .replaceAll('{notification_id}', notificationId);

    // ignore: prefer_final_locals
    Object? postBody = getNotificationRequestBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Notification History
  ///
  /// -> View the devices sent a message - OneSignal Paid Plan Required This method will return all devices that were sent the given notification_id of an Email or Push Notification if used within 7 days of the date sent. After 7 days of the sending date, the message history data will be unavailable. After a successful response is received, the destination url may be polled until the file becomes available. Most exports are done in ~1-3 minutes, so setting a poll interval of 10 seconds should be adequate. For use cases that are not meant to be consumed by a script, an email will be sent to the supplied email address. &#x1F6A7; Requirements A OneSignal Paid Plan. Turn on Send History via OneSignal API in Settings -> Analytics. Cannot get data before this was turned on. Must be called within 7 days after sending the message. Messages targeting under 1000 recipients will not have \"sent\" events recorded, but will show \"clicked\" events. Requires your OneSignal App's REST API Key, available in Keys & IDs.
  ///
  /// Parameters:
  ///
  /// * [String] notificationId (required):
  ///   The \"id\" of the message found in the Notification object
  ///
  /// * [GetNotificationRequestBody] getNotificationRequestBody (required):
  Future<NotificationHistorySuccessResponse?> getNotificationHistory(
    String notificationId,
    GetNotificationRequestBody getNotificationRequestBody,
  ) async {
    final response = await getNotificationHistoryWithHttpInfo(
      notificationId,
      getNotificationRequestBody,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'NotificationHistorySuccessResponse',
      ) as NotificationHistorySuccessResponse;
    }
    return null;
  }

  /// View notifications
  ///
  /// View the details of multiple notifications
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The app ID that you want to view notifications from
  ///
  /// * [int] limit:
  ///   How many notifications to return.  Max is 50.  Default is 50.
  ///
  /// * [int] offset:
  ///   Page offset.  Default is 0.  Results are sorted by queued_at in descending order.  queued_at is a representation of the time that the notification was queued at.
  ///
  /// * [int] kind:
  ///   Kind of notifications returned:   * unset - All notification types (default)   * `0` - Dashboard only   * `1` - API only   * `3` - Automated only
  Future<Response> getNotificationsWithHttpInfo(
    String appId, {
    int? limit,
    int? offset,
    int? kind,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/notifications';

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    queryParams.addAll(_queryParams('', 'app_id', appId));
    if (limit != null) {
      queryParams.addAll(_queryParams('', 'limit', limit));
    }
    if (offset != null) {
      queryParams.addAll(_queryParams('', 'offset', offset));
    }
    if (kind != null) {
      queryParams.addAll(_queryParams('', 'kind', kind));
    }

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View notifications
  ///
  /// View the details of multiple notifications
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The app ID that you want to view notifications from
  ///
  /// * [int] limit:
  ///   How many notifications to return.  Max is 50.  Default is 50.
  ///
  /// * [int] offset:
  ///   Page offset.  Default is 0.  Results are sorted by queued_at in descending order.  queued_at is a representation of the time that the notification was queued at.
  ///
  /// * [int] kind:
  ///   Kind of notifications returned:   * unset - All notification types (default)   * `0` - Dashboard only   * `1` - API only   * `3` - Automated only
  Future<NotificationSlice?> getNotifications(
    String appId, {
    int? limit,
    int? offset,
    int? kind,
  }) async {
    final response = await getNotificationsWithHttpInfo(
      appId,
      limit: limit,
      offset: offset,
      kind: kind,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'NotificationSlice',
      ) as NotificationSlice;
    }
    return null;
  }

  /// View Outcomes
  ///
  /// View the details of all the outcomes associated with your app  &#x1F6A7; Requires Authentication Key Requires your OneSignal App's REST API Key, available in Keys & IDs.  &#x1F6A7; Outcome Data Limitations Outcomes are only accessible for around 30 days before deleted from our servers. You will need to export this data every month if you want to keep it.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID for your app.  Available in Keys & IDs.
  ///
  /// * [String] outcomeNames (required):
  ///   Required Comma-separated list of names and the value (sum/count) for the returned outcome data. Note: Clicks only support count aggregation. For out-of-the-box OneSignal outcomes such as click and session duration, please use the \"os\" prefix with two underscores. For other outcomes, please use the name specified by the user. Example:os__session_duration.count,os__click.count,CustomOutcomeName.sum
  ///
  /// * [String] outcomeNamesLeftSquareBracketRightSquareBracket:
  ///   Optional If outcome names contain any commas, then please specify only one value at a time. Example: outcome_names[]=os__click.count&outcome_names[]=Sales, Purchase.count where \"Sales, Purchase\" is the custom outcomes with a comma in the name.
  ///
  /// * [String] outcomeTimeRange:
  ///   Optional Time range for the returned data. The values can be 1h (for the last 1 hour data), 1d (for the last 1 day data), or 1mo (for the last 1 month data). Default is 1h if the parameter is omitted.
  ///
  /// * [String] outcomePlatforms:
  ///   Optional Platform id. Refer device's platform ids for values. Example: outcome_platform=0 for iOS outcome_platform=7,8 for Safari and Firefox Default is data from all platforms if the parameter is omitted.
  ///
  /// * [String] outcomeAttribution:
  ///   Optional Attribution type for the outcomes. The values can be direct or influenced or unattributed. Example: outcome_attribution=direct Default is total (returns direct+influenced+unattributed) if the parameter is omitted.
  Future<Response> getOutcomesWithHttpInfo(
    String appId,
    String outcomeNames, {
    String? outcomeNamesLeftSquareBracketRightSquareBracket,
    String? outcomeTimeRange,
    String? outcomePlatforms,
    String? outcomeAttribution,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/apps/{app_id}/outcomes'.replaceAll('{app_id}', appId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    queryParams.addAll(_queryParams('', 'outcome_names', outcomeNames));
    if (outcomeNamesLeftSquareBracketRightSquareBracket != null) {
      queryParams.addAll(_queryParams('', 'outcome_names[]',
          outcomeNamesLeftSquareBracketRightSquareBracket));
    }
    if (outcomeTimeRange != null) {
      queryParams
          .addAll(_queryParams('', 'outcome_time_range', outcomeTimeRange));
    }
    if (outcomePlatforms != null) {
      queryParams
          .addAll(_queryParams('', 'outcome_platforms', outcomePlatforms));
    }
    if (outcomeAttribution != null) {
      queryParams
          .addAll(_queryParams('', 'outcome_attribution', outcomeAttribution));
    }

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View Outcomes
  ///
  /// View the details of all the outcomes associated with your app  &#x1F6A7; Requires Authentication Key Requires your OneSignal App's REST API Key, available in Keys & IDs.  &#x1F6A7; Outcome Data Limitations Outcomes are only accessible for around 30 days before deleted from our servers. You will need to export this data every month if you want to keep it.
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID for your app.  Available in Keys & IDs.
  ///
  /// * [String] outcomeNames (required):
  ///   Required Comma-separated list of names and the value (sum/count) for the returned outcome data. Note: Clicks only support count aggregation. For out-of-the-box OneSignal outcomes such as click and session duration, please use the \"os\" prefix with two underscores. For other outcomes, please use the name specified by the user. Example:os__session_duration.count,os__click.count,CustomOutcomeName.sum
  ///
  /// * [String] outcomeNamesLeftSquareBracketRightSquareBracket:
  ///   Optional If outcome names contain any commas, then please specify only one value at a time. Example: outcome_names[]=os__click.count&outcome_names[]=Sales, Purchase.count where \"Sales, Purchase\" is the custom outcomes with a comma in the name.
  ///
  /// * [String] outcomeTimeRange:
  ///   Optional Time range for the returned data. The values can be 1h (for the last 1 hour data), 1d (for the last 1 day data), or 1mo (for the last 1 month data). Default is 1h if the parameter is omitted.
  ///
  /// * [String] outcomePlatforms:
  ///   Optional Platform id. Refer device's platform ids for values. Example: outcome_platform=0 for iOS outcome_platform=7,8 for Safari and Firefox Default is data from all platforms if the parameter is omitted.
  ///
  /// * [String] outcomeAttribution:
  ///   Optional Attribution type for the outcomes. The values can be direct or influenced or unattributed. Example: outcome_attribution=direct Default is total (returns direct+influenced+unattributed) if the parameter is omitted.
  Future<OutcomesData?> getOutcomes(
    String appId,
    String outcomeNames, {
    String? outcomeNamesLeftSquareBracketRightSquareBracket,
    String? outcomeTimeRange,
    String? outcomePlatforms,
    String? outcomeAttribution,
  }) async {
    final response = await getOutcomesWithHttpInfo(
      appId,
      outcomeNames,
      outcomeNamesLeftSquareBracketRightSquareBracket:
          outcomeNamesLeftSquareBracketRightSquareBracket,
      outcomeTimeRange: outcomeTimeRange,
      outcomePlatforms: outcomePlatforms,
      outcomeAttribution: outcomeAttribution,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'OutcomesData',
      ) as OutcomesData;
    }
    return null;
  }

  /// View device
  ///
  /// View the details of an existing device in one of your OneSignal apps
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   Your app_id for this device
  ///
  /// * [String] playerId (required):
  ///   Player's OneSignal ID
  ///
  /// * [String] emailAuthHash:
  ///   Email - Only required if you have enabled Identity Verification and device_type is email (11).
  Future<Response> getPlayerWithHttpInfo(
    String appId,
    String playerId, {
    String? emailAuthHash,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/players/{player_id}'.replaceAll('{player_id}', playerId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    queryParams.addAll(_queryParams('', 'app_id', appId));
    if (emailAuthHash != null) {
      queryParams.addAll(_queryParams('', 'email_auth_hash', emailAuthHash));
    }

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View device
  ///
  /// View the details of an existing device in one of your OneSignal apps
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   Your app_id for this device
  ///
  /// * [String] playerId (required):
  ///   Player's OneSignal ID
  ///
  /// * [String] emailAuthHash:
  ///   Email - Only required if you have enabled Identity Verification and device_type is email (11).
  Future<Player?> getPlayer(
    String appId,
    String playerId, {
    String? emailAuthHash,
  }) async {
    final response = await getPlayerWithHttpInfo(
      appId,
      playerId,
      emailAuthHash: emailAuthHash,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'Player',
      ) as Player;
    }
    return null;
  }

  /// View devices
  ///
  /// View the details of multiple devices in one of your OneSignal apps Unavailable for Apps Over 80,000 Users For performance reasons, this method is not available for larger apps. Larger apps should use the CSV export API endpoint, which is much more performant.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The app ID that you want to view players from
  ///
  /// * [int] limit:
  ///   How many devices to return. Max is 300. Default is 300
  ///
  /// * [int] offset:
  ///   Result offset. Default is 0. Results are sorted by id;
  Future<Response> getPlayersWithHttpInfo(
    String appId, {
    int? limit,
    int? offset,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/players';

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    queryParams.addAll(_queryParams('', 'app_id', appId));
    if (limit != null) {
      queryParams.addAll(_queryParams('', 'limit', limit));
    }
    if (offset != null) {
      queryParams.addAll(_queryParams('', 'offset', offset));
    }

    const contentTypes = <String>[];

    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View devices
  ///
  /// View the details of multiple devices in one of your OneSignal apps Unavailable for Apps Over 80,000 Users For performance reasons, this method is not available for larger apps. Larger apps should use the CSV export API endpoint, which is much more performant.
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The app ID that you want to view players from
  ///
  /// * [int] limit:
  ///   How many devices to return. Max is 300. Default is 300
  ///
  /// * [int] offset:
  ///   Result offset. Default is 0. Results are sorted by id;
  Future<PlayerSlice?> getPlayers(
    String appId, {
    int? limit,
    int? offset,
  }) async {
    final response = await getPlayersWithHttpInfo(
      appId,
      limit: limit,
      offset: offset,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'PlayerSlice',
      ) as PlayerSlice;
    }
    return null;
  }

  /// Update an app
  ///
  /// Updates the name or configuration settings of an existing OneSignal app
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   An app id
  ///
  /// * [App] app (required):
  Future<Response> updateAppWithHttpInfo(
    String appId,
    App app,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/apps/{app_id}'.replaceAll('{app_id}', appId);

    // ignore: prefer_final_locals
    Object? postBody = app;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Update an app
  ///
  /// Updates the name or configuration settings of an existing OneSignal app
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   An app id
  ///
  /// * [App] app (required):
  Future<App?> updateApp(
    String appId,
    App app,
  ) async {
    final response = await updateAppWithHttpInfo(
      appId,
      app,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'App',
      ) as App;
    }
    return null;
  }

  /// Edit device
  ///
  /// Update an existing device in one of your OneSignal apps
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] playerId (required):
  ///   Player's OneSignal ID
  ///
  /// * [Player] player (required):
  Future<Response> updatePlayerWithHttpInfo(
    String playerId,
    Player player,
  ) async {
    // ignore: prefer_const_declarations
    final path = r'/players/{player_id}'.replaceAll('{player_id}', playerId);

    // ignore: prefer_final_locals
    Object? postBody = player;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Edit device
  ///
  /// Update an existing device in one of your OneSignal apps
  ///
  /// Parameters:
  ///
  /// * [String] playerId (required):
  ///   Player's OneSignal ID
  ///
  /// * [Player] player (required):
  Future<UpdatePlayerSuccessResponse?> updatePlayer(
    String playerId,
    Player player,
  ) async {
    final response = await updatePlayerWithHttpInfo(
      playerId,
      player,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'UpdatePlayerSuccessResponse',
      ) as UpdatePlayerSuccessResponse;
    }
    return null;
  }

  /// Edit tags with external user id
  ///
  /// Update an existing device's tags in one of your OneSignal apps using the External User ID. Warning - Android SDK Data Synchronization Tags added through the Android SDK tagging methods may not update if using the API to change or update the same tag. For example, if you use SDK method sendTag(\"key\", \"value1\") then update the tag value to \"value2\" with this API endpoint. You will not be able to set the value back to \"value1\" through the SDK, you will need to change it to something different through the SDK to be reset. Recommendations if using this Endpoint on Android Mobile Apps: 1 - Do not use the same tag keys for SDK and API updates 2 - If you want to use the same key for both SDK and API updates, call the SDK getTags method first to update the device's tags. This is only applicable on the Android Mobile App SDKs. &#128216; Deleting Tags To delete a tag, include its key and set its value to blank. Omitting a key/value will not delete it. For example, if I wanted to delete two existing tags rank and category while simultaneously adding a new tag class, the tags JSON would look like the following: \"tags\": {    \"rank\": \"\",    \"category\": \"\",    \"class\": \"my_new_value\" }
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID the user record is found under.
  ///
  /// * [String] externalUserId (required):
  ///   The External User ID mapped to teh device record in OneSignal.  Must be actively set on the device to be updated.
  ///
  /// * [UpdatePlayerTagsRequestBody] updatePlayerTagsRequestBody:
  Future<Response> updatePlayerTagsWithHttpInfo(
    String appId,
    String externalUserId, {
    UpdatePlayerTagsRequestBody? updatePlayerTagsRequestBody,
  }) async {
    // ignore: prefer_const_declarations
    final path = r'/apps/{app_id}/users/{external_user_id}'
        .replaceAll('{app_id}', appId)
        .replaceAll('{external_user_id}', externalUserId);

    // ignore: prefer_final_locals
    Object? postBody = updatePlayerTagsRequestBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json'];

    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Edit tags with external user id
  ///
  /// Update an existing device's tags in one of your OneSignal apps using the External User ID. Warning - Android SDK Data Synchronization Tags added through the Android SDK tagging methods may not update if using the API to change or update the same tag. For example, if you use SDK method sendTag(\"key\", \"value1\") then update the tag value to \"value2\" with this API endpoint. You will not be able to set the value back to \"value1\" through the SDK, you will need to change it to something different through the SDK to be reset. Recommendations if using this Endpoint on Android Mobile Apps: 1 - Do not use the same tag keys for SDK and API updates 2 - If you want to use the same key for both SDK and API updates, call the SDK getTags method first to update the device's tags. This is only applicable on the Android Mobile App SDKs. &#128216; Deleting Tags To delete a tag, include its key and set its value to blank. Omitting a key/value will not delete it. For example, if I wanted to delete two existing tags rank and category while simultaneously adding a new tag class, the tags JSON would look like the following: \"tags\": {    \"rank\": \"\",    \"category\": \"\",    \"class\": \"my_new_value\" }
  ///
  /// Parameters:
  ///
  /// * [String] appId (required):
  ///   The OneSignal App ID the user record is found under.
  ///
  /// * [String] externalUserId (required):
  ///   The External User ID mapped to teh device record in OneSignal.  Must be actively set on the device to be updated.
  ///
  /// * [UpdatePlayerTagsRequestBody] updatePlayerTagsRequestBody:
  Future<UpdatePlayerTagsSuccessResponse?> updatePlayerTags(
    String appId,
    String externalUserId, {
    UpdatePlayerTagsRequestBody? updatePlayerTagsRequestBody,
  }) async {
    final response = await updatePlayerTagsWithHttpInfo(
      appId,
      externalUserId,
      updatePlayerTagsRequestBody: updatePlayerTagsRequestBody,
    );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty &&
        response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(
        await _decodeBodyBytes(response),
        'UpdatePlayerTagsSuccessResponse',
      ) as UpdatePlayerTagsSuccessResponse;
    }
    return null;
  }
}
