//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of one_signal_api;

class FilterExpressions {
  /// Returns a new [FilterExpressions] instance.
  FilterExpressions({
    required this.field,
    this.key,
    this.value,
    required this.relation,
    this.operator_,
  });

  /// Name of the field to use as the first operand in the filter expression.
  String field;

  /// If `field` is `tag`, this field is *required* to specify `key` inside the tags.
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? key;

  /// Constant value to use as the second operand in the filter expression.  This value is *required* when the relation operator is a binary operator.
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  String? value;

  /// Operator of a filter expression.
  FilterExpressionsRelationEnum relation;

  /// Strictly, this must be either `\"OR\"`, or `\"AND\"`.  It can be used to compose Filters as part of a Filters object.
  FilterExpressionsOperator_Enum? operator_;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is FilterExpressions &&
          other.field == field &&
          other.key == key &&
          other.value == value &&
          other.relation == relation &&
          other.operator_ == operator_;

  @override
  int get hashCode =>
      // ignore: unnecessary_parenthesis
      (field.hashCode) +
      (key == null ? 0 : key!.hashCode) +
      (value == null ? 0 : value!.hashCode) +
      (relation.hashCode) +
      (operator_ == null ? 0 : operator_!.hashCode);

  @override
  String toString() =>
      'FilterExpressions[field=$field, key=$key, value=$value, relation=$relation, operator_=$operator_]';

  Map<String, dynamic> toJson() {
    final _json = <String, dynamic>{};
    _json[r'field'] = field;
    if (key != null) {
      _json[r'key'] = key;
    }
    if (value != null) {
      _json[r'value'] = value;
    }
    _json[r'relation'] = relation;
    if (operator_ != null) {
      _json[r'operator'] = operator_;
    }
    return _json;
  }

  /// Returns a new [FilterExpressions] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static FilterExpressions? fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();

      // Ensure that the map contains the required keys.
      // Note 1: the values aren't checked for validity beyond being non-null.
      // Note 2: this code is stripped in release mode!
      assert(() {
        requiredKeys.forEach((key) {
          assert(json.containsKey(key),
              'Required key "FilterExpressions[$key]" is missing from JSON.');
          assert(json[key] != null,
              'Required key "FilterExpressions[$key]" has a null value in JSON.');
        });
        return true;
      }());

      return FilterExpressions(
        field: mapValueOfType<String>(json, r'field')!,
        key: mapValueOfType<String>(json, r'key'),
        value: mapValueOfType<String>(json, r'value'),
        relation: FilterExpressionsRelationEnum.fromJson(json[r'relation'])!,
        operator_: FilterExpressionsOperator_Enum.fromJson(json[r'operator']),
      );
    }
    return null;
  }

  static List<FilterExpressions>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <FilterExpressions>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = FilterExpressions.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }

  static Map<String, FilterExpressions> mapFromJson(dynamic json) {
    final map = <String, FilterExpressions>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = FilterExpressions.fromJson(entry.value);
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  // maps a json object with a list of FilterExpressions-objects as value to a dart map
  static Map<String, List<FilterExpressions>> mapListFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final map = <String, List<FilterExpressions>>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = FilterExpressions.listFromJson(
          entry.value,
          growable: growable,
        );
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  /// The list of required keys that must be present in a JSON.
  static const requiredKeys = <String>{
    'field',
    'relation',
  };
}

/// Operator of a filter expression.
class FilterExpressionsRelationEnum {
  /// Instantiate a new enum with the provided [value].
  const FilterExpressionsRelationEnum._(this.value);

  /// The underlying value of this enum member.
  final String value;

  @override
  String toString() => value;

  String toJson() => value;

  static const greaterThan = FilterExpressionsRelationEnum._(r'>');
  static const lessThan = FilterExpressionsRelationEnum._(r'<');
  static const equal = FilterExpressionsRelationEnum._(r'=');
  static const exclamationEqual = FilterExpressionsRelationEnum._(r'!=');
  static const exists = FilterExpressionsRelationEnum._(r'exists');
  static const notExists = FilterExpressionsRelationEnum._(r'not_exists');
  static const timeElapsedGt =
      FilterExpressionsRelationEnum._(r'time_elapsed_gt');
  static const timeElapsedLt =
      FilterExpressionsRelationEnum._(r'time_elapsed_lt');

  /// List of all possible values in this [enum][FilterExpressionsRelationEnum].
  static const values = <FilterExpressionsRelationEnum>[
    greaterThan,
    lessThan,
    equal,
    exclamationEqual,
    exists,
    notExists,
    timeElapsedGt,
    timeElapsedLt,
  ];

  static FilterExpressionsRelationEnum? fromJson(dynamic value) =>
      FilterExpressionsRelationEnumTypeTransformer().decode(value);

  static List<FilterExpressionsRelationEnum>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <FilterExpressionsRelationEnum>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = FilterExpressionsRelationEnum.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }
}

/// Transformation class that can [encode] an instance of [FilterExpressionsRelationEnum] to String,
/// and [decode] dynamic data back to [FilterExpressionsRelationEnum].
class FilterExpressionsRelationEnumTypeTransformer {
  factory FilterExpressionsRelationEnumTypeTransformer() =>
      _instance ??= const FilterExpressionsRelationEnumTypeTransformer._();

  const FilterExpressionsRelationEnumTypeTransformer._();

  String encode(FilterExpressionsRelationEnum data) => data.value;

  /// Decodes a [dynamic value][data] to a FilterExpressionsRelationEnum.
  ///
  /// If [allowNull] is true and the [dynamic value][data] cannot be decoded successfully,
  /// then null is returned. However, if [allowNull] is false and the [dynamic value][data]
  /// cannot be decoded successfully, then an [UnimplementedError] is thrown.
  ///
  /// The [allowNull] is very handy when an API changes and a new enum value is added or removed,
  /// and users are still using an old app with the old code.
  FilterExpressionsRelationEnum? decode(dynamic data, {bool allowNull = true}) {
    if (data != null) {
      switch (data.toString()) {
        case r'>':
          return FilterExpressionsRelationEnum.greaterThan;
        case r'<':
          return FilterExpressionsRelationEnum.lessThan;
        case r'=':
          return FilterExpressionsRelationEnum.equal;
        case r'!=':
          return FilterExpressionsRelationEnum.exclamationEqual;
        case r'exists':
          return FilterExpressionsRelationEnum.exists;
        case r'not_exists':
          return FilterExpressionsRelationEnum.notExists;
        case r'time_elapsed_gt':
          return FilterExpressionsRelationEnum.timeElapsedGt;
        case r'time_elapsed_lt':
          return FilterExpressionsRelationEnum.timeElapsedLt;
        default:
          if (!allowNull) {
            throw ArgumentError('Unknown enum value to decode: $data');
          }
      }
    }
    return null;
  }

  /// Singleton [FilterExpressionsRelationEnumTypeTransformer] instance.
  static FilterExpressionsRelationEnumTypeTransformer? _instance;
}

/// Strictly, this must be either `\"OR\"`, or `\"AND\"`.  It can be used to compose Filters as part of a Filters object.
class FilterExpressionsOperator_Enum {
  /// Instantiate a new enum with the provided [value].
  const FilterExpressionsOperator_Enum._(this.value);

  /// The underlying value of this enum member.
  final String value;

  @override
  String toString() => value;

  String toJson() => value;

  static const OR = FilterExpressionsOperator_Enum._(r'OR');
  static const AND = FilterExpressionsOperator_Enum._(r'AND');

  /// List of all possible values in this [enum][FilterExpressionsOperator_Enum].
  static const values = <FilterExpressionsOperator_Enum>[
    OR,
    AND,
  ];

  static FilterExpressionsOperator_Enum? fromJson(dynamic value) =>
      FilterExpressionsOperator_EnumTypeTransformer().decode(value);

  static List<FilterExpressionsOperator_Enum>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <FilterExpressionsOperator_Enum>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = FilterExpressionsOperator_Enum.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }
}

/// Transformation class that can [encode] an instance of [FilterExpressionsOperator_Enum] to String,
/// and [decode] dynamic data back to [FilterExpressionsOperator_Enum].
class FilterExpressionsOperator_EnumTypeTransformer {
  factory FilterExpressionsOperator_EnumTypeTransformer() =>
      _instance ??= const FilterExpressionsOperator_EnumTypeTransformer._();

  const FilterExpressionsOperator_EnumTypeTransformer._();

  String encode(FilterExpressionsOperator_Enum data) => data.value;

  /// Decodes a [dynamic value][data] to a FilterExpressionsOperator_Enum.
  ///
  /// If [allowNull] is true and the [dynamic value][data] cannot be decoded successfully,
  /// then null is returned. However, if [allowNull] is false and the [dynamic value][data]
  /// cannot be decoded successfully, then an [UnimplementedError] is thrown.
  ///
  /// The [allowNull] is very handy when an API changes and a new enum value is added or removed,
  /// and users are still using an old app with the old code.
  FilterExpressionsOperator_Enum? decode(dynamic data,
      {bool allowNull = true}) {
    if (data != null) {
      switch (data.toString()) {
        case r'OR':
          return FilterExpressionsOperator_Enum.OR;
        case r'AND':
          return FilterExpressionsOperator_Enum.AND;
        default:
          if (!allowNull) {
            throw ArgumentError('Unknown enum value to decode: $data');
          }
      }
    }
    return null;
  }

  /// Singleton [FilterExpressionsOperator_EnumTypeTransformer] instance.
  static FilterExpressionsOperator_EnumTypeTransformer? _instance;
}
