//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of one_signal_api;

class PlayerNotificationTarget {
  /// Returns a new [PlayerNotificationTarget] instance.
  PlayerNotificationTarget({
    this.includePlayerIds = const [],
    this.includeExternalUserIds = const [],
    this.includeEmailTokens = const [],
    this.includePhoneNumbers = const [],
    this.includeIosTokens = const [],
    this.includeWpWnsUris = const [],
    this.includeAmazonRegIds = const [],
    this.includeChromeRegIds = const [],
    this.includeChromeWebRegIds = const [],
    this.includeAndroidRegIds = const [],
  });

  /// Specific playerids to send your notification to. _Does not require API Auth Key. Do not combine with other targeting parameters. Not compatible with any other targeting parameters. Example: [\"1dd608f2-c6a1-11e3-851d-000c2940e62c\"] Limit of 2,000 entries per REST API call
  List<String> includePlayerIds;

  /// Target specific devices by custom user IDs assigned via API. Not compatible with any other targeting parameters Example: [\"custom-id-assigned-by-api\"] REQUIRED: REST API Key Authentication Limit of 2,000 entries per REST API call. Note: If targeting push, email, or sms subscribers with same ids, use with channel_for_external_user_ids to indicate you are sending a push or email or sms.
  List<String> includeExternalUserIds;

  /// Recommended for Sending Emails - Target specific email addresses. If an email does not correspond to an existing user, a new user will be created. Example: nick@catfac.ts Limit of 2,000 entries per REST API call
  List<String> includeEmailTokens;

  /// Recommended for Sending SMS - Target specific phone numbers. The phone number should be in the E.164 format. Phone number should be an existing subscriber on OneSignal. Refer our docs to learn how to add phone numbers to OneSignal. Example phone number: +1999999999 Limit of 2,000 entries per REST API call
  List<String> includePhoneNumbers;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using iOS device tokens. Warning: Only works with Production tokens. All non-alphanumeric characters must be removed from each token. If a token does not correspond to an existing user, a new user will be created. Example: ce777617da7f548fe7a9ab6febb56cf39fba6d38203... Limit of 2,000 entries per REST API call
  List<String> includeIosTokens;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Windows URIs. If a token does not correspond to an existing user, a new user will be created. Example: http://s.notify.live.net/u/1/bn1/HmQAAACPaLDr-... Limit of 2,000 entries per REST API call
  List<String> includeWpWnsUris;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Amazon ADM registration IDs. If a token does not correspond to an existing user, a new user will be created. Example: amzn1.adm-registration.v1.XpvSSUk0Rc3hTVVV... Limit of 2,000 entries per REST API call
  List<String> includeAmazonRegIds;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Chrome App registration IDs. If a token does not correspond to an existing user, a new user will be created. Example: APA91bEeiUeSukAAUdnw3O2RB45FWlSpgJ7Ji_... Limit of 2,000 entries per REST API call
  List<String> includeChromeRegIds;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Chrome Web Push registration IDs. If a token does not correspond to an existing user, a new user will be created. Example: APA91bEeiUeSukAAUdnw3O2RB45FWlSpgJ7Ji_... Limit of 2,000 entries per REST API call
  List<String> includeChromeWebRegIds;

  /// Not Recommended: Please consider using include_player_ids or include_external_user_ids instead. Target using Android device registration IDs. If a token does not correspond to an existing user, a new user will be created. Example: APA91bEeiUeSukAAUdnw3O2RB45FWlSpgJ7Ji_... Limit of 2,000 entries per REST API call
  List<String> includeAndroidRegIds;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is PlayerNotificationTarget &&
          other.includePlayerIds == includePlayerIds &&
          other.includeExternalUserIds == includeExternalUserIds &&
          other.includeEmailTokens == includeEmailTokens &&
          other.includePhoneNumbers == includePhoneNumbers &&
          other.includeIosTokens == includeIosTokens &&
          other.includeWpWnsUris == includeWpWnsUris &&
          other.includeAmazonRegIds == includeAmazonRegIds &&
          other.includeChromeRegIds == includeChromeRegIds &&
          other.includeChromeWebRegIds == includeChromeWebRegIds &&
          other.includeAndroidRegIds == includeAndroidRegIds;

  @override
  int get hashCode =>
      // ignore: unnecessary_parenthesis
      (includePlayerIds.hashCode) +
      (includeExternalUserIds.hashCode) +
      (includeEmailTokens.hashCode) +
      (includePhoneNumbers.hashCode) +
      (includeIosTokens.hashCode) +
      (includeWpWnsUris.hashCode) +
      (includeAmazonRegIds.hashCode) +
      (includeChromeRegIds.hashCode) +
      (includeChromeWebRegIds.hashCode) +
      (includeAndroidRegIds.hashCode);

  @override
  String toString() =>
      'PlayerNotificationTarget[includePlayerIds=$includePlayerIds, includeExternalUserIds=$includeExternalUserIds, includeEmailTokens=$includeEmailTokens, includePhoneNumbers=$includePhoneNumbers, includeIosTokens=$includeIosTokens, includeWpWnsUris=$includeWpWnsUris, includeAmazonRegIds=$includeAmazonRegIds, includeChromeRegIds=$includeChromeRegIds, includeChromeWebRegIds=$includeChromeWebRegIds, includeAndroidRegIds=$includeAndroidRegIds]';

  Map<String, dynamic> toJson() {
    final _json = <String, dynamic>{};
    _json[r'include_player_ids'] = includePlayerIds;
    _json[r'include_external_user_ids'] = includeExternalUserIds;
    _json[r'include_email_tokens'] = includeEmailTokens;
    _json[r'include_phone_numbers'] = includePhoneNumbers;
    _json[r'include_ios_tokens'] = includeIosTokens;
    _json[r'include_wp_wns_uris'] = includeWpWnsUris;
    _json[r'include_amazon_reg_ids'] = includeAmazonRegIds;
    _json[r'include_chrome_reg_ids'] = includeChromeRegIds;
    _json[r'include_chrome_web_reg_ids'] = includeChromeWebRegIds;
    _json[r'include_android_reg_ids'] = includeAndroidRegIds;
    return _json;
  }

  /// Returns a new [PlayerNotificationTarget] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static PlayerNotificationTarget? fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();

      // Ensure that the map contains the required keys.
      // Note 1: the values aren't checked for validity beyond being non-null.
      // Note 2: this code is stripped in release mode!
      assert(() {
        requiredKeys.forEach((key) {
          assert(json.containsKey(key),
              'Required key "PlayerNotificationTarget[$key]" is missing from JSON.');
          assert(json[key] != null,
              'Required key "PlayerNotificationTarget[$key]" has a null value in JSON.');
        });
        return true;
      }());

      return PlayerNotificationTarget(
        includePlayerIds: json[r'include_player_ids'] is List
            ? (json[r'include_player_ids'] as List).cast<String>()
            : const [],
        includeExternalUserIds: json[r'include_external_user_ids'] is List
            ? (json[r'include_external_user_ids'] as List).cast<String>()
            : const [],
        includeEmailTokens: json[r'include_email_tokens'] is List
            ? (json[r'include_email_tokens'] as List).cast<String>()
            : const [],
        includePhoneNumbers: json[r'include_phone_numbers'] is List
            ? (json[r'include_phone_numbers'] as List).cast<String>()
            : const [],
        includeIosTokens: json[r'include_ios_tokens'] is List
            ? (json[r'include_ios_tokens'] as List).cast<String>()
            : const [],
        includeWpWnsUris: json[r'include_wp_wns_uris'] is List
            ? (json[r'include_wp_wns_uris'] as List).cast<String>()
            : const [],
        includeAmazonRegIds: json[r'include_amazon_reg_ids'] is List
            ? (json[r'include_amazon_reg_ids'] as List).cast<String>()
            : const [],
        includeChromeRegIds: json[r'include_chrome_reg_ids'] is List
            ? (json[r'include_chrome_reg_ids'] as List).cast<String>()
            : const [],
        includeChromeWebRegIds: json[r'include_chrome_web_reg_ids'] is List
            ? (json[r'include_chrome_web_reg_ids'] as List).cast<String>()
            : const [],
        includeAndroidRegIds: json[r'include_android_reg_ids'] is List
            ? (json[r'include_android_reg_ids'] as List).cast<String>()
            : const [],
      );
    }
    return null;
  }

  static List<PlayerNotificationTarget>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <PlayerNotificationTarget>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = PlayerNotificationTarget.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }

  static Map<String, PlayerNotificationTarget> mapFromJson(dynamic json) {
    final map = <String, PlayerNotificationTarget>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = PlayerNotificationTarget.fromJson(entry.value);
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  // maps a json object with a list of PlayerNotificationTarget-objects as value to a dart map
  static Map<String, List<PlayerNotificationTarget>> mapListFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final map = <String, List<PlayerNotificationTarget>>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = PlayerNotificationTarget.listFromJson(
          entry.value,
          growable: growable,
        );
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  /// The list of required keys that must be present in a JSON.
  static const requiredKeys = <String>{};
}
