//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of one_signal_api;

class Purchase {
  /// Returns a new [Purchase] instance.
  Purchase({
    required this.sku,
    required this.amount,
    required this.iso,
  });

  /// The unique identifier of the purchased item.
  String sku;

  /// The amount, in USD, spent purchasing the item.
  num? amount;

  /// The 3-letter ISO 4217 currency code. Required for correct storage and conversion of amount.
  String iso;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is Purchase &&
          other.sku == sku &&
          other.amount == amount &&
          other.iso == iso;

  @override
  int get hashCode =>
      // ignore: unnecessary_parenthesis
      (sku.hashCode) + (amount.hashCode) + (iso.hashCode);

  @override
  String toString() => 'Purchase[sku=$sku, amount=$amount, iso=$iso]';

  Map<String, dynamic> toJson() {
    final _json = <String, dynamic>{};
    _json[r'sku'] = sku;
    _json[r'amount'] = amount;
    _json[r'iso'] = iso;
    return _json;
  }

  /// Returns a new [Purchase] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static Purchase? fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();

      // Ensure that the map contains the required keys.
      // Note 1: the values aren't checked for validity beyond being non-null.
      // Note 2: this code is stripped in release mode!
      assert(() {
        requiredKeys.forEach((key) {
          assert(json.containsKey(key),
              'Required key "Purchase[$key]" is missing from JSON.');
          assert(json[key] != null,
              'Required key "Purchase[$key]" has a null value in JSON.');
        });
        return true;
      }());

      return Purchase(
        sku: mapValueOfType<String>(json, r'sku')!,
        amount: json[r'amount'] == null
            ? null
            : num.parse(json[r'amount'].toString()),
        iso: mapValueOfType<String>(json, r'iso')!,
      );
    }
    return null;
  }

  static List<Purchase>? listFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final result = <Purchase>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = Purchase.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }

  static Map<String, Purchase> mapFromJson(dynamic json) {
    final map = <String, Purchase>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = Purchase.fromJson(entry.value);
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  // maps a json object with a list of Purchase-objects as value to a dart map
  static Map<String, List<Purchase>> mapListFromJson(
    dynamic json, {
    bool growable = false,
  }) {
    final map = <String, List<Purchase>>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = Purchase.listFromJson(
          entry.value,
          growable: growable,
        );
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  /// The list of required keys that must be present in a JSON.
  static const requiredKeys = <String>{
    'sku',
    'amount',
    'iso',
  };
}
